part of trober_sdk.api;

// AppInfo
class AppInfo {
  late String minVersion;
  AppInfo({
    required this.minVersion,
  });

  @override
  String toString() {
    return 'AppInfo[minVersion=$minVersion, ]';
  }

  fromJson(Map<String, dynamic>? json) {
    if (json == null) return;

    {
      final _jsonData = json[r'minVersion'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'minVersion', r'',
            'minVersion field is null and is required to have a value');
      minVersion = (_jsonData as String);
    }
  }

  AppInfo.fromJson(Map<String, dynamic>? json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'minVersion'] = minVersion;
    return json;
  }

  static List<AppInfo> listFromJson(List<dynamic>? json) {
    return json == null
        ? <AppInfo>[]
        : json.map((value) => AppInfo.fromJson(value)).toList();
  }

  static Map<String, AppInfo> mapFromJson(Map<String, dynamic>? json) {
    final map = <String, AppInfo>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = AppInfo.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object? other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is AppInfo && runtimeType == other.runtimeType) {
      return minVersion == other.minVersion;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    hashCode = hashCode * 31 + minVersion.hashCode;

    return hashCode;
  }

  AppInfo copyWith({
    String? minVersion,
  }) {
    minVersion ??= this.minVersion;

    final _copy_minVersion = minVersion;

    return AppInfo(
      minVersion: _copy_minVersion,
    );
  }
}
