part of trober_sdk.api;

// Carrier
class Carrier {
  late String id = '00000000-0000-0000-0000-000000000000';

  DateTime? createdAt;

  DateTime? updatedAt;

  String? createdBy;

  late String tenantId;

  late String name;

  DateTime? eta;

  late CarrierType type;
  Carrier({
    required this.id,
    this.createdAt,
    this.updatedAt,
    this.createdBy,
    required this.tenantId,
    required this.name,
    this.eta,
    required this.type,
  });

  @override
  String toString() {
    return 'Carrier[id=$id, createdAt=$createdAt, updatedAt=$updatedAt, createdBy=$createdBy, tenantId=$tenantId, name=$name, eta=$eta, type=$type, ]';
  }

  fromJson(Map<String, dynamic>? json) {
    if (json == null) return;

    {
      final _jsonData = json[r'id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'id', r'',
            'id field is null and is required to have a value');
      id = (_jsonData as String);
    }

    createdAt = (json[r'created_at'] == null)
        ? null
        : DateTime.parse(json[r'created_at']);

    updatedAt = (json[r'updated_at'] == null)
        ? null
        : DateTime.parse(json[r'updated_at']);

    createdBy =
        (json[r'created_by'] == null) ? null : (json[r'created_by'] as String);

    {
      final _jsonData = json[r'tenant_id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'tenant_id', r'',
            'tenantId field is null and is required to have a value');
      tenantId = (_jsonData as String);
    }

    {
      final _jsonData = json[r'name'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'name', r'',
            'name field is null and is required to have a value');
      name = (_jsonData as String);
    }

    eta = (json[r'eta'] == null) ? null : DateTime.parse(json[r'eta']);

    {
      final _jsonData = json[r'type'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'type', r'',
            'type field is null and is required to have a value');

      final _enumVal = CarrierTypeExtension.fromJson(_jsonData);
      if (_enumVal == null)
        throw DeserialisationError(json, r'type', r'',
            'CarrierType has no valid translation from $_enumVal');
      type = _enumVal;
    }
  }

  Carrier.fromJson(Map<String, dynamic>? json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'id'] = id;
    if (createdAt != null) {
      json[r'created_at'] = createdAt?.toUtc().toIso8601String();
    }
    if (updatedAt != null) {
      json[r'updated_at'] = updatedAt?.toUtc().toIso8601String();
    }
    if (createdBy != null) {
      json[r'created_by'] = createdBy;
    }
    json[r'tenant_id'] = tenantId;
    json[r'name'] = name;
    if (eta != null) {
      json[r'eta'] = eta?.toUtc().toIso8601String();
    }
    json[r'type'] = type.toJson();
    return json;
  }

  static List<Carrier> listFromJson(List<dynamic>? json) {
    return json == null
        ? <Carrier>[]
        : json.map((value) => Carrier.fromJson(value)).toList();
  }

  static Map<String, Carrier> mapFromJson(Map<String, dynamic>? json) {
    final map = <String, Carrier>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = Carrier.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object? other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is Carrier && runtimeType == other.runtimeType) {
      return id == other.id &&
          createdAt == other.createdAt && // other

          updatedAt == other.updatedAt && // other

          createdBy == other.createdBy &&
          tenantId == other.tenantId &&
          name == other.name &&
          eta == other.eta && // other

          type == other.type;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    hashCode = hashCode * 31 + id.hashCode;

    if (createdAt != null) {
      hashCode = hashCode * 31 + createdAt.hashCode;
    }

    if (updatedAt != null) {
      hashCode = hashCode * 31 + updatedAt.hashCode;
    }

    if (createdBy != null) {
      hashCode = hashCode * 31 + createdBy.hashCode;
    }

    hashCode = hashCode * 31 + tenantId.hashCode;

    hashCode = hashCode * 31 + name.hashCode;

    if (eta != null) {
      hashCode = hashCode * 31 + eta.hashCode;
    }

    hashCode = hashCode * 31 + type.hashCode;

    return hashCode;
  }

  Carrier copyWith({
    String? id,
    DateTime? createdAt,
    DateTime? updatedAt,
    String? createdBy,
    String? tenantId,
    String? name,
    DateTime? eta,
    CarrierType? type,
  }) {
    id ??= this.id;
    createdAt ??= this.createdAt;
    updatedAt ??= this.updatedAt;
    createdBy ??= this.createdBy;
    tenantId ??= this.tenantId;
    name ??= this.name;
    eta ??= this.eta;
    type ??= this.type;

    final _copy_id = id;
    final _copy_createdAt = createdAt;
    final _copy_updatedAt = updatedAt;
    final _copy_createdBy = createdBy;
    final _copy_tenantId = tenantId;
    final _copy_name = name;
    final _copy_eta = eta;
    final _copy_type = type;

    return Carrier(
      id: _copy_id,
      createdAt: _copy_createdAt,
      updatedAt: _copy_updatedAt,
      createdBy: _copy_createdBy,
      tenantId: _copy_tenantId,
      name: _copy_name,
      eta: _copy_eta,
      type: _copy_type,
    );
  }
}
