part of trober_sdk.api;

enum CarrierType { air, rail, vessel, road }

extension CarrierTypeExtension on CarrierType {
  String? get name => toMap[this];

  // you have to call this extension class to use this as this is not yet supported
  static CarrierType? type(String name) => fromMap[name];

  static Map<String, CarrierType> fromMap = {
    'Air': CarrierType.air,
    'Rail': CarrierType.rail,
    'Vessel': CarrierType.vessel,
    'Road': CarrierType.road
  };
  static Map<CarrierType, String> toMap = {
    CarrierType.air: 'Air',
    CarrierType.rail: 'Rail',
    CarrierType.vessel: 'Vessel',
    CarrierType.road: 'Road'
  };

  static CarrierType? fromJson(dynamic? data) =>
      data == null ? null : fromMap[data];

  dynamic toJson() => toMap[this];

  static List<CarrierType> listFromJson(List<dynamic>? json) => json == null
      ? <CarrierType>[]
      : json.map((value) => fromJson(value)).toList().fromNull();

  static CarrierType copyWith(CarrierType instance) => instance;

  static Map<String, CarrierType> mapFromJson(Map<String, dynamic?>? json) {
    final map = <String, CarrierType>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic? value) {
        final val = fromJson(value);
        if (val != null) {
          map[key] = val;
        }
      });
    }
    return map;
  }
}
