part of trober_sdk.api;

// Customer
class Customer {
  late String id = '00000000-0000-0000-0000-000000000000';

  late DateTime createdAt;

  late DateTime updatedAt;

  String? createdBy;

  late String tenantId;

  late String name;
  Customer({
    required this.id,
    required this.createdAt,
    required this.updatedAt,
    this.createdBy,
    required this.tenantId,
    required this.name,
  });

  @override
  String toString() {
    return 'Customer[id=$id, createdAt=$createdAt, updatedAt=$updatedAt, createdBy=$createdBy, tenantId=$tenantId, name=$name, ]';
  }

  fromJson(Map<String, dynamic>? json) {
    if (json == null) return;

    {
      final _jsonData = json[r'id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'id', r'',
            'id field is null and is required to have a value');
      id = (_jsonData as String);
    }

    {
      final _jsonData = json[r'created_at'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'created_at', r'',
            'createdAt field is null and is required to have a value');
      createdAt = DateTime.parse(_jsonData);
    }

    {
      final _jsonData = json[r'updated_at'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'updated_at', r'',
            'updatedAt field is null and is required to have a value');
      updatedAt = DateTime.parse(_jsonData);
    }

    createdBy =
        (json[r'created_by'] == null) ? null : (json[r'created_by'] as String);

    {
      final _jsonData = json[r'tenant_id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'tenant_id', r'',
            'tenantId field is null and is required to have a value');
      tenantId = (_jsonData as String);
    }

    {
      final _jsonData = json[r'name'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'name', r'',
            'name field is null and is required to have a value');
      name = (_jsonData as String);
    }
  }

  Customer.fromJson(Map<String, dynamic>? json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'id'] = id;
    json[r'created_at'] = createdAt.toUtc().toIso8601String();
    json[r'updated_at'] = updatedAt.toUtc().toIso8601String();
    if (createdBy != null) {
      json[r'created_by'] = createdBy;
    }
    json[r'tenant_id'] = tenantId;
    json[r'name'] = name;
    return json;
  }

  static List<Customer> listFromJson(List<dynamic>? json) {
    return json == null
        ? <Customer>[]
        : json.map((value) => Customer.fromJson(value)).toList();
  }

  static Map<String, Customer> mapFromJson(Map<String, dynamic>? json) {
    final map = <String, Customer>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = Customer.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object? other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is Customer && runtimeType == other.runtimeType) {
      return id == other.id &&
          createdAt == other.createdAt && // other

          updatedAt == other.updatedAt && // other

          createdBy == other.createdBy &&
          tenantId == other.tenantId &&
          name == other.name;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    hashCode = hashCode * 31 + id.hashCode;

    hashCode = hashCode * 31 + createdAt.hashCode;

    hashCode = hashCode * 31 + updatedAt.hashCode;

    if (createdBy != null) {
      hashCode = hashCode * 31 + createdBy.hashCode;
    }

    hashCode = hashCode * 31 + tenantId.hashCode;

    hashCode = hashCode * 31 + name.hashCode;

    return hashCode;
  }

  Customer copyWith({
    String? id,
    DateTime? createdAt,
    DateTime? updatedAt,
    String? createdBy,
    String? tenantId,
    String? name,
  }) {
    id ??= this.id;
    createdAt ??= this.createdAt;
    updatedAt ??= this.updatedAt;
    createdBy ??= this.createdBy;
    tenantId ??= this.tenantId;
    name ??= this.name;

    final _copy_id = id;
    final _copy_createdAt = createdAt;
    final _copy_updatedAt = updatedAt;
    final _copy_createdBy = createdBy;
    final _copy_tenantId = tenantId;
    final _copy_name = name;

    return Customer(
      id: _copy_id,
      createdAt: _copy_createdAt,
      updatedAt: _copy_updatedAt,
      createdBy: _copy_createdBy,
      tenantId: _copy_tenantId,
      name: _copy_name,
    );
  }
}
