part of trober_sdk.api;

// DeviceId
class DeviceId {
  late String token;
  DeviceId({
    required this.token,
  });

  @override
  String toString() {
    return 'DeviceId[token=$token, ]';
  }

  fromJson(Map<String, dynamic>? json) {
    if (json == null) return;

    {
      final _jsonData = json[r'token'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'token', r'',
            'token field is null and is required to have a value');
      token = (_jsonData as String);
    }
  }

  DeviceId.fromJson(Map<String, dynamic>? json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'token'] = token;
    return json;
  }

  static List<DeviceId> listFromJson(List<dynamic>? json) {
    return json == null
        ? <DeviceId>[]
        : json.map((value) => DeviceId.fromJson(value)).toList();
  }

  static Map<String, DeviceId> mapFromJson(Map<String, dynamic>? json) {
    final map = <String, DeviceId>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = DeviceId.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object? other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is DeviceId && runtimeType == other.runtimeType) {
      return token == other.token;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    hashCode = hashCode * 31 + token.hashCode;

    return hashCode;
  }

  DeviceId copyWith({
    String? token,
  }) {
    token ??= this.token;

    final _copy_token = token;

    return DeviceId(
      token: _copy_token,
    );
  }
}
