part of trober_sdk.api;

// Error
class Error {
  late int code;

  late String message;

  late String id;
  Error({
    required this.code,
    required this.message,
    required this.id,
  });

  @override
  String toString() {
    return 'Error[code=$code, message=$message, id=$id, ]';
  }

  fromJson(Map<String, dynamic>? json) {
    if (json == null) return;

    {
      final _jsonData = json[r'code'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'code', r'',
            'code field is null and is required to have a value');
      code = (_jsonData as int);
    }

    {
      final _jsonData = json[r'message'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'message', r'',
            'message field is null and is required to have a value');
      message = (_jsonData as String);
    }

    {
      final _jsonData = json[r'id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'id', r'',
            'id field is null and is required to have a value');
      id = (_jsonData as String);
    }
  }

  Error.fromJson(Map<String, dynamic>? json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'code'] = code;
    json[r'message'] = message;
    json[r'id'] = id;
    return json;
  }

  static List<Error> listFromJson(List<dynamic>? json) {
    return json == null
        ? <Error>[]
        : json.map((value) => Error.fromJson(value)).toList();
  }

  static Map<String, Error> mapFromJson(Map<String, dynamic>? json) {
    final map = <String, Error>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = Error.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object? other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is Error && runtimeType == other.runtimeType) {
      return code == other.code && message == other.message && id == other.id;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    hashCode = hashCode * 31 + code.hashCode;

    hashCode = hashCode * 31 + message.hashCode;

    hashCode = hashCode * 31 + id.hashCode;

    return hashCode;
  }

  Error copyWith({
    int? code,
    String? message,
    String? id,
  }) {
    code ??= this.code;
    message ??= this.message;
    id ??= this.id;

    final _copy_code = code;
    final _copy_message = message;
    final _copy_id = id;

    return Error(
      code: _copy_code,
      message: _copy_message,
      id: _copy_id,
    );
  }
}
