part of trober_sdk.api;

// Order
class Order {
  late String id;

  late DateTime createdAt;

  late DateTime updatedAt;

  String? createdBy;

  late String tenantId;

  String? customerId;

  late String serialNumber;

  late OrderStatus status;

  Customer? customer;
  Order({
    required this.id,
    required this.createdAt,
    required this.updatedAt,
    this.createdBy,
    required this.tenantId,
    this.customerId,
    required this.serialNumber,
    required this.status,
    this.customer,
  });

  @override
  String toString() {
    return 'Order[id=$id, createdAt=$createdAt, updatedAt=$updatedAt, createdBy=$createdBy, tenantId=$tenantId, customerId=$customerId, serialNumber=$serialNumber, status=$status, customer=$customer, ]';
  }

  fromJson(Map<String, dynamic>? json) {
    if (json == null) return;

    {
      final _jsonData = json[r'id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'id', r'',
            'id field is null and is required to have a value');
      id = (_jsonData as String);
    }

    {
      final _jsonData = json[r'created_at'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'created_at', r'',
            'createdAt field is null and is required to have a value');
      createdAt = DateTime.parse(_jsonData);
    }

    {
      final _jsonData = json[r'updated_at'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'updated_at', r'',
            'updatedAt field is null and is required to have a value');
      updatedAt = DateTime.parse(_jsonData);
    }

    createdBy =
        (json[r'created_by'] == null) ? null : (json[r'created_by'] as String);

    {
      final _jsonData = json[r'tenant_id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'tenant_id', r'',
            'tenantId field is null and is required to have a value');
      tenantId = (_jsonData as String);
    }

    customerId = (json[r'customer_id'] == null)
        ? null
        : (json[r'customer_id'] as String);

    {
      final _jsonData = json[r'serial_number'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'serial_number', r'',
            'serialNumber field is null and is required to have a value');
      serialNumber = (_jsonData as String);
    }

    {
      final _jsonData = json[r'status'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'status', r'',
            'status field is null and is required to have a value');

      final _enumVal = OrderStatusExtension.fromJson(_jsonData);
      if (_enumVal == null)
        throw DeserialisationError(json, r'status', r'',
            'OrderStatus has no valid translation from $_enumVal');
      status = _enumVal;
    }

    customer = (json[r'customer'] == null)
        ? null
        : Customer.fromJson(json[r'customer']);
  }

  Order.fromJson(Map<String, dynamic>? json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'id'] = id;
    json[r'created_at'] = createdAt.toUtc().toIso8601String();
    json[r'updated_at'] = updatedAt.toUtc().toIso8601String();
    if (createdBy != null) {
      json[r'created_by'] = createdBy;
    }
    json[r'tenant_id'] = tenantId;
    if (customerId != null) {
      json[r'customer_id'] = customerId;
    }
    json[r'serial_number'] = serialNumber;
    json[r'status'] = status.toJson();
    if (customer != null) {
      json[r'customer'] = customer?.toJson();
    }
    return json;
  }

  static List<Order> listFromJson(List<dynamic>? json) {
    return json == null
        ? <Order>[]
        : json.map((value) => Order.fromJson(value)).toList();
  }

  static Map<String, Order> mapFromJson(Map<String, dynamic>? json) {
    final map = <String, Order>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = Order.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object? other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is Order && runtimeType == other.runtimeType) {
      return id == other.id &&
          createdAt == other.createdAt && // other

          updatedAt == other.updatedAt && // other

          createdBy == other.createdBy &&
          tenantId == other.tenantId &&
          customerId == other.customerId &&
          serialNumber == other.serialNumber &&
          status == other.status && // other

          customer == other.customer;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    hashCode = hashCode * 31 + id.hashCode;

    hashCode = hashCode * 31 + createdAt.hashCode;

    hashCode = hashCode * 31 + updatedAt.hashCode;

    if (createdBy != null) {
      hashCode = hashCode * 31 + createdBy.hashCode;
    }

    hashCode = hashCode * 31 + tenantId.hashCode;

    if (customerId != null) {
      hashCode = hashCode * 31 + customerId.hashCode;
    }

    hashCode = hashCode * 31 + serialNumber.hashCode;

    hashCode = hashCode * 31 + status.hashCode;

    if (customer != null) {
      hashCode = hashCode * 31 + customer.hashCode;
    }

    return hashCode;
  }

  Order copyWith({
    String? id,
    DateTime? createdAt,
    DateTime? updatedAt,
    String? createdBy,
    String? tenantId,
    String? customerId,
    String? serialNumber,
    OrderStatus? status,
    Customer? customer,
  }) {
    id ??= this.id;
    createdAt ??= this.createdAt;
    updatedAt ??= this.updatedAt;
    createdBy ??= this.createdBy;
    tenantId ??= this.tenantId;
    customerId ??= this.customerId;
    serialNumber ??= this.serialNumber;
    status ??= this.status;
    customer ??= this.customer;

    final _copy_id = id;
    final _copy_createdAt = createdAt;
    final _copy_updatedAt = updatedAt;
    final _copy_createdBy = createdBy;
    final _copy_tenantId = tenantId;
    final _copy_customerId = customerId;
    final _copy_serialNumber = serialNumber;
    final _copy_status = status;
    final _copy_customer = customer?.copyWith();

    return Order(
      id: _copy_id,
      createdAt: _copy_createdAt,
      updatedAt: _copy_updatedAt,
      createdBy: _copy_createdBy,
      tenantId: _copy_tenantId,
      customerId: _copy_customerId,
      serialNumber: _copy_serialNumber,
      status: _copy_status,
      customer: _copy_customer,
    );
  }
}
