part of trober_sdk.api;

enum OrderStatus {
  open,
  accepted,
  cancelled,
  inProgress,
  delivered,
  invoiced,
  paymentReceived
}

extension OrderStatusExtension on OrderStatus {
  String? get name => toMap[this];

  // you have to call this extension class to use this as this is not yet supported
  static OrderStatus? type(String name) => fromMap[name];

  static Map<String, OrderStatus> fromMap = {
    'Open': OrderStatus.open,
    'Accepted': OrderStatus.accepted,
    'Cancelled': OrderStatus.cancelled,
    'InProgress': OrderStatus.inProgress,
    'Delivered': OrderStatus.delivered,
    'Invoiced': OrderStatus.invoiced,
    'PaymentReceived': OrderStatus.paymentReceived
  };
  static Map<OrderStatus, String> toMap = {
    OrderStatus.open: 'Open',
    OrderStatus.accepted: 'Accepted',
    OrderStatus.cancelled: 'Cancelled',
    OrderStatus.inProgress: 'InProgress',
    OrderStatus.delivered: 'Delivered',
    OrderStatus.invoiced: 'Invoiced',
    OrderStatus.paymentReceived: 'PaymentReceived'
  };

  static OrderStatus? fromJson(dynamic? data) =>
      data == null ? null : fromMap[data];

  dynamic toJson() => toMap[this];

  static List<OrderStatus> listFromJson(List<dynamic>? json) => json == null
      ? <OrderStatus>[]
      : json.map((value) => fromJson(value)).toList().fromNull();

  static OrderStatus copyWith(OrderStatus instance) => instance;

  static Map<String, OrderStatus> mapFromJson(Map<String, dynamic?>? json) {
    final map = <String, OrderStatus>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic? value) {
        final val = fromJson(value);
        if (val != null) {
          map[key] = val;
        }
      });
    }
    return map;
  }
}
