part of trober_sdk.api;

// Shipment
class Shipment {
  late String id = '00000000-0000-0000-0000-000000000000';

  late DateTime createdAt;

  late DateTime updatedAt;

  String? createdBy;

  late String tenantId;

  String? carrierId;

  String? orderId;

  String? customerId;

  late String serialNumber;

  String? origin;

  String? destination;

  DateTime? reservationTime;

  ShipmentSize? size;

  late ShipmentType type;

  ShipmentStatus? status;

  String? driverId;

  User? driver;

  Order? order;

  Customer? customer;

  Carrier? carrier;
  Shipment({
    required this.id,
    required this.createdAt,
    required this.updatedAt,
    this.createdBy,
    required this.tenantId,
    this.carrierId,
    this.orderId,
    this.customerId,
    required this.serialNumber,
    this.origin,
    this.destination,
    this.reservationTime,
    this.size,
    required this.type,
    this.status,
    this.driverId,
    this.driver,
    this.order,
    this.customer,
    this.carrier,
  });

  @override
  String toString() {
    return 'Shipment[id=$id, createdAt=$createdAt, updatedAt=$updatedAt, createdBy=$createdBy, tenantId=$tenantId, carrierId=$carrierId, orderId=$orderId, customerId=$customerId, serialNumber=$serialNumber, origin=$origin, destination=$destination, reservationTime=$reservationTime, size=$size, type=$type, status=$status, driverId=$driverId, driver=$driver, order=$order, customer=$customer, carrier=$carrier, ]';
  }

  fromJson(Map<String, dynamic>? json) {
    if (json == null) return;

    {
      final _jsonData = json[r'id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'id', r'',
            'id field is null and is required to have a value');
      id = (_jsonData as String);
    }

    {
      final _jsonData = json[r'created_at'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'created_at', r'',
            'createdAt field is null and is required to have a value');
      createdAt = DateTime.parse(_jsonData);
    }

    {
      final _jsonData = json[r'updated_at'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'updated_at', r'',
            'updatedAt field is null and is required to have a value');
      updatedAt = DateTime.parse(_jsonData);
    }

    createdBy =
        (json[r'created_by'] == null) ? null : (json[r'created_by'] as String);

    {
      final _jsonData = json[r'tenant_id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'tenant_id', r'',
            'tenantId field is null and is required to have a value');
      tenantId = (_jsonData as String);
    }

    carrierId =
        (json[r'carrier_id'] == null) ? null : (json[r'carrier_id'] as String);

    orderId =
        (json[r'order_id'] == null) ? null : (json[r'order_id'] as String);

    customerId = (json[r'customer_id'] == null)
        ? null
        : (json[r'customer_id'] as String);

    {
      final _jsonData = json[r'serial_number'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'serial_number', r'',
            'serialNumber field is null and is required to have a value');
      serialNumber = (_jsonData as String);
    }

    origin = (json[r'origin'] == null) ? null : (json[r'origin'] as String);

    destination = (json[r'destination'] == null)
        ? null
        : (json[r'destination'] as String);

    reservationTime = (json[r'reservation_time'] == null)
        ? null
        : DateTime.parse(json[r'reservation_time']);

    size = (json[r'size'] == null)
        ? null
        : ShipmentSizeExtension.fromJson(json[r'size']);

    {
      final _jsonData = json[r'type'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'type', r'',
            'type field is null and is required to have a value');

      final _enumVal = ShipmentTypeExtension.fromJson(_jsonData);
      if (_enumVal == null)
        throw DeserialisationError(json, r'type', r'',
            'ShipmentType has no valid translation from $_enumVal');
      type = _enumVal;
    }

    status = (json[r'status'] == null)
        ? null
        : ShipmentStatusExtension.fromJson(json[r'status']);

    driverId =
        (json[r'driver_id'] == null) ? null : (json[r'driver_id'] as String);

    driver = (json[r'driver'] == null) ? null : User.fromJson(json[r'driver']);

    order = (json[r'order'] == null) ? null : Order.fromJson(json[r'order']);

    customer = (json[r'customer'] == null)
        ? null
        : Customer.fromJson(json[r'customer']);

    carrier =
        (json[r'carrier'] == null) ? null : Carrier.fromJson(json[r'carrier']);
  }

  Shipment.fromJson(Map<String, dynamic>? json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'id'] = id;
    json[r'created_at'] = createdAt.toUtc().toIso8601String();
    json[r'updated_at'] = updatedAt.toUtc().toIso8601String();
    if (createdBy != null) {
      json[r'created_by'] = createdBy;
    }
    json[r'tenant_id'] = tenantId;
    if (carrierId != null) {
      json[r'carrier_id'] = carrierId;
    }
    if (orderId != null) {
      json[r'order_id'] = orderId;
    }
    if (customerId != null) {
      json[r'customer_id'] = customerId;
    }
    json[r'serial_number'] = serialNumber;
    if (origin != null) {
      json[r'origin'] = origin;
    }
    if (destination != null) {
      json[r'destination'] = destination;
    }
    if (reservationTime != null) {
      json[r'reservation_time'] = reservationTime?.toUtc().toIso8601String();
    }
    if (size != null) {
      json[r'size'] = size?.toJson();
    }
    json[r'type'] = type.toJson();
    if (status != null) {
      json[r'status'] = status?.toJson();
    }
    if (driverId != null) {
      json[r'driver_id'] = driverId;
    }
    if (driver != null) {
      json[r'driver'] = driver?.toJson();
    }
    if (order != null) {
      json[r'order'] = order?.toJson();
    }
    if (customer != null) {
      json[r'customer'] = customer?.toJson();
    }
    if (carrier != null) {
      json[r'carrier'] = carrier?.toJson();
    }
    return json;
  }

  static List<Shipment> listFromJson(List<dynamic>? json) {
    return json == null
        ? <Shipment>[]
        : json.map((value) => Shipment.fromJson(value)).toList();
  }

  static Map<String, Shipment> mapFromJson(Map<String, dynamic>? json) {
    final map = <String, Shipment>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = Shipment.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object? other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is Shipment && runtimeType == other.runtimeType) {
      return id == other.id &&
          createdAt == other.createdAt && // other

          updatedAt == other.updatedAt && // other

          createdBy == other.createdBy &&
          tenantId == other.tenantId &&
          carrierId == other.carrierId &&
          orderId == other.orderId &&
          customerId == other.customerId &&
          serialNumber == other.serialNumber &&
          origin == other.origin &&
          destination == other.destination &&
          reservationTime == other.reservationTime && // other

          size == other.size && // other

          type == other.type && // other

          status == other.status && // other

          driverId == other.driverId &&
          driver == other.driver && // other

          order == other.order && // other

          customer == other.customer && // other

          carrier == other.carrier;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    hashCode = hashCode * 31 + id.hashCode;

    hashCode = hashCode * 31 + createdAt.hashCode;

    hashCode = hashCode * 31 + updatedAt.hashCode;

    if (createdBy != null) {
      hashCode = hashCode * 31 + createdBy.hashCode;
    }

    hashCode = hashCode * 31 + tenantId.hashCode;

    if (carrierId != null) {
      hashCode = hashCode * 31 + carrierId.hashCode;
    }

    if (orderId != null) {
      hashCode = hashCode * 31 + orderId.hashCode;
    }

    if (customerId != null) {
      hashCode = hashCode * 31 + customerId.hashCode;
    }

    hashCode = hashCode * 31 + serialNumber.hashCode;

    if (origin != null) {
      hashCode = hashCode * 31 + origin.hashCode;
    }

    if (destination != null) {
      hashCode = hashCode * 31 + destination.hashCode;
    }

    if (reservationTime != null) {
      hashCode = hashCode * 31 + reservationTime.hashCode;
    }

    if (size != null) {
      hashCode = hashCode * 31 + size.hashCode;
    }

    hashCode = hashCode * 31 + type.hashCode;

    if (status != null) {
      hashCode = hashCode * 31 + status.hashCode;
    }

    if (driverId != null) {
      hashCode = hashCode * 31 + driverId.hashCode;
    }

    if (driver != null) {
      hashCode = hashCode * 31 + driver.hashCode;
    }

    if (order != null) {
      hashCode = hashCode * 31 + order.hashCode;
    }

    if (customer != null) {
      hashCode = hashCode * 31 + customer.hashCode;
    }

    if (carrier != null) {
      hashCode = hashCode * 31 + carrier.hashCode;
    }

    return hashCode;
  }

  Shipment copyWith({
    String? id,
    DateTime? createdAt,
    DateTime? updatedAt,
    String? createdBy,
    String? tenantId,
    String? carrierId,
    String? orderId,
    String? customerId,
    String? serialNumber,
    String? origin,
    String? destination,
    DateTime? reservationTime,
    ShipmentSize? size,
    ShipmentType? type,
    ShipmentStatus? status,
    String? driverId,
    User? driver,
    Order? order,
    Customer? customer,
    Carrier? carrier,
  }) {
    id ??= this.id;
    createdAt ??= this.createdAt;
    updatedAt ??= this.updatedAt;
    createdBy ??= this.createdBy;
    tenantId ??= this.tenantId;
    carrierId ??= this.carrierId;
    orderId ??= this.orderId;
    customerId ??= this.customerId;
    serialNumber ??= this.serialNumber;
    origin ??= this.origin;
    destination ??= this.destination;
    reservationTime ??= this.reservationTime;
    size ??= this.size;
    type ??= this.type;
    status ??= this.status;
    driverId ??= this.driverId;
    driver ??= this.driver;
    order ??= this.order;
    customer ??= this.customer;
    carrier ??= this.carrier;

    final _copy_id = id;
    final _copy_createdAt = createdAt;
    final _copy_updatedAt = updatedAt;
    final _copy_createdBy = createdBy;
    final _copy_tenantId = tenantId;
    final _copy_carrierId = carrierId;
    final _copy_orderId = orderId;
    final _copy_customerId = customerId;
    final _copy_serialNumber = serialNumber;
    final _copy_origin = origin;
    final _copy_destination = destination;
    final _copy_reservationTime = reservationTime;
    final _copy_size = size;
    final _copy_type = type;
    final _copy_status = status;
    final _copy_driverId = driverId;
    final _copy_driver = driver?.copyWith();
    final _copy_order = order?.copyWith();
    final _copy_customer = customer?.copyWith();
    final _copy_carrier = carrier?.copyWith();

    return Shipment(
      id: _copy_id,
      createdAt: _copy_createdAt,
      updatedAt: _copy_updatedAt,
      createdBy: _copy_createdBy,
      tenantId: _copy_tenantId,
      carrierId: _copy_carrierId,
      orderId: _copy_orderId,
      customerId: _copy_customerId,
      serialNumber: _copy_serialNumber,
      origin: _copy_origin,
      destination: _copy_destination,
      reservationTime: _copy_reservationTime,
      size: _copy_size,
      type: _copy_type,
      status: _copy_status,
      driverId: _copy_driverId,
      driver: _copy_driver,
      order: _copy_order,
      customer: _copy_customer,
      carrier: _copy_carrier,
    );
  }
}
