part of trober_sdk.api;

enum ShipmentSize { n40sT, n20sT, n40hC, n40hW, custom }

extension ShipmentSizeExtension on ShipmentSize {
  String? get name => toMap[this];

  // you have to call this extension class to use this as this is not yet supported
  static ShipmentSize? type(String name) => fromMap[name];

  static Map<String, ShipmentSize> fromMap = {
    '40ST': ShipmentSize.n40sT,
    '20ST': ShipmentSize.n20sT,
    '40HC': ShipmentSize.n40hC,
    '40HW': ShipmentSize.n40hW,
    'Custom': ShipmentSize.custom
  };
  static Map<ShipmentSize, String> toMap = {
    ShipmentSize.n40sT: '40ST',
    ShipmentSize.n20sT: '20ST',
    ShipmentSize.n40hC: '40HC',
    ShipmentSize.n40hW: '40HW',
    ShipmentSize.custom: 'Custom'
  };

  static ShipmentSize? fromJson(dynamic? data) =>
      data == null ? null : fromMap[data];

  dynamic toJson() => toMap[this];

  static List<ShipmentSize> listFromJson(List<dynamic>? json) => json == null
      ? <ShipmentSize>[]
      : json.map((value) => fromJson(value)).toList().fromNull();

  static ShipmentSize copyWith(ShipmentSize instance) => instance;

  static Map<String, ShipmentSize> mapFromJson(Map<String, dynamic?>? json) {
    final map = <String, ShipmentSize>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic? value) {
        final val = fromJson(value);
        if (val != null) {
          map[key] = val;
        }
      });
    }
    return map;
  }
}
