part of trober_sdk.api;

enum ShipmentStatus {
  unassigned,
  inTransit,
  arrived,
  assigned,
  accepted,
  rejected,
  loaded,
  delivered
}

extension ShipmentStatusExtension on ShipmentStatus {
  String? get name => toMap[this];

  // you have to call this extension class to use this as this is not yet supported
  static ShipmentStatus? type(String name) => fromMap[name];

  static Map<String, ShipmentStatus> fromMap = {
    'Unassigned': ShipmentStatus.unassigned,
    'InTransit': ShipmentStatus.inTransit,
    'Arrived': ShipmentStatus.arrived,
    'Assigned': ShipmentStatus.assigned,
    'Accepted': ShipmentStatus.accepted,
    'Rejected': ShipmentStatus.rejected,
    'Loaded': ShipmentStatus.loaded,
    'Delivered': ShipmentStatus.delivered
  };
  static Map<ShipmentStatus, String> toMap = {
    ShipmentStatus.unassigned: 'Unassigned',
    ShipmentStatus.inTransit: 'InTransit',
    ShipmentStatus.arrived: 'Arrived',
    ShipmentStatus.assigned: 'Assigned',
    ShipmentStatus.accepted: 'Accepted',
    ShipmentStatus.rejected: 'Rejected',
    ShipmentStatus.loaded: 'Loaded',
    ShipmentStatus.delivered: 'Delivered'
  };

  static ShipmentStatus? fromJson(dynamic? data) =>
      data == null ? null : fromMap[data];

  dynamic toJson() => toMap[this];

  static List<ShipmentStatus> listFromJson(List<dynamic>? json) => json == null
      ? <ShipmentStatus>[]
      : json.map((value) => fromJson(value)).toList().fromNull();

  static ShipmentStatus copyWith(ShipmentStatus instance) => instance;

  static Map<String, ShipmentStatus> mapFromJson(Map<String, dynamic?>? json) {
    final map = <String, ShipmentStatus>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic? value) {
        final val = fromJson(value);
        if (val != null) {
          map[key] = val;
        }
      });
    }
    return map;
  }
}
