part of trober_sdk.api;

enum ShipmentType { inbound, outbound }

extension ShipmentTypeExtension on ShipmentType {
  String? get name => toMap[this];

  // you have to call this extension class to use this as this is not yet supported
  static ShipmentType? type(String name) => fromMap[name];

  static Map<String, ShipmentType> fromMap = {
    'Inbound': ShipmentType.inbound,
    'Outbound': ShipmentType.outbound
  };
  static Map<ShipmentType, String> toMap = {
    ShipmentType.inbound: 'Inbound',
    ShipmentType.outbound: 'Outbound'
  };

  static ShipmentType? fromJson(dynamic? data) =>
      data == null ? null : fromMap[data];

  dynamic toJson() => toMap[this];

  static List<ShipmentType> listFromJson(List<dynamic>? json) => json == null
      ? <ShipmentType>[]
      : json.map((value) => fromJson(value)).toList().fromNull();

  static ShipmentType copyWith(ShipmentType instance) => instance;

  static Map<String, ShipmentType> mapFromJson(Map<String, dynamic?>? json) {
    final map = <String, ShipmentType>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic? value) {
        final val = fromJson(value);
        if (val != null) {
          map[key] = val;
        }
      });
    }
    return map;
  }
}
