part of trober_sdk.api;

// Tenant
class Tenant {
  late String id;

  late DateTime createdAt;

  late DateTime updatedAt;

  String? createdBy;

  late String name;

  late String code;

  late TenantType type;
  Tenant({
    required this.id,
    required this.createdAt,
    required this.updatedAt,
    this.createdBy,
    required this.name,
    required this.code,
    required this.type,
  });

  @override
  String toString() {
    return 'Tenant[id=$id, createdAt=$createdAt, updatedAt=$updatedAt, createdBy=$createdBy, name=$name, code=$code, type=$type, ]';
  }

  fromJson(Map<String, dynamic>? json) {
    if (json == null) return;

    {
      final _jsonData = json[r'id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'id', r'',
            'id field is null and is required to have a value');
      id = (_jsonData as String);
    }

    {
      final _jsonData = json[r'created_at'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'created_at', r'',
            'createdAt field is null and is required to have a value');
      createdAt = DateTime.parse(_jsonData);
    }

    {
      final _jsonData = json[r'updated_at'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'updated_at', r'',
            'updatedAt field is null and is required to have a value');
      updatedAt = DateTime.parse(_jsonData);
    }

    createdBy =
        (json[r'created_by'] == null) ? null : (json[r'created_by'] as String);

    {
      final _jsonData = json[r'name'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'name', r'',
            'name field is null and is required to have a value');
      name = (_jsonData as String);
    }

    {
      final _jsonData = json[r'code'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'code', r'',
            'code field is null and is required to have a value');
      code = (_jsonData as String);
    }

    {
      final _jsonData = json[r'type'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'type', r'',
            'type field is null and is required to have a value');

      final _enumVal = TenantTypeExtension.fromJson(_jsonData);
      if (_enumVal == null)
        throw DeserialisationError(json, r'type', r'',
            'TenantType has no valid translation from $_enumVal');
      type = _enumVal;
    }
  }

  Tenant.fromJson(Map<String, dynamic>? json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'id'] = id;
    json[r'created_at'] = createdAt.toUtc().toIso8601String();
    json[r'updated_at'] = updatedAt.toUtc().toIso8601String();
    if (createdBy != null) {
      json[r'created_by'] = createdBy;
    }
    json[r'name'] = name;
    json[r'code'] = code;
    json[r'type'] = type.toJson();
    return json;
  }

  static List<Tenant> listFromJson(List<dynamic>? json) {
    return json == null
        ? <Tenant>[]
        : json.map((value) => Tenant.fromJson(value)).toList();
  }

  static Map<String, Tenant> mapFromJson(Map<String, dynamic>? json) {
    final map = <String, Tenant>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = Tenant.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object? other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is Tenant && runtimeType == other.runtimeType) {
      return id == other.id &&
          createdAt == other.createdAt && // other

          updatedAt == other.updatedAt && // other

          createdBy == other.createdBy &&
          name == other.name &&
          code == other.code &&
          type == other.type;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    hashCode = hashCode * 31 + id.hashCode;

    hashCode = hashCode * 31 + createdAt.hashCode;

    hashCode = hashCode * 31 + updatedAt.hashCode;

    if (createdBy != null) {
      hashCode = hashCode * 31 + createdBy.hashCode;
    }

    hashCode = hashCode * 31 + name.hashCode;

    hashCode = hashCode * 31 + code.hashCode;

    hashCode = hashCode * 31 + type.hashCode;

    return hashCode;
  }

  Tenant copyWith({
    String? id,
    DateTime? createdAt,
    DateTime? updatedAt,
    String? createdBy,
    String? name,
    String? code,
    TenantType? type,
  }) {
    id ??= this.id;
    createdAt ??= this.createdAt;
    updatedAt ??= this.updatedAt;
    createdBy ??= this.createdBy;
    name ??= this.name;
    code ??= this.code;
    type ??= this.type;

    final _copy_id = id;
    final _copy_createdAt = createdAt;
    final _copy_updatedAt = updatedAt;
    final _copy_createdBy = createdBy;
    final _copy_name = name;
    final _copy_code = code;
    final _copy_type = type;

    return Tenant(
      id: _copy_id,
      createdAt: _copy_createdAt,
      updatedAt: _copy_updatedAt,
      createdBy: _copy_createdBy,
      name: _copy_name,
      code: _copy_code,
      type: _copy_type,
    );
  }
}
