part of trober_sdk.api;

enum TenantType { system, test, production }

extension TenantTypeExtension on TenantType {
  String? get name => toMap[this];

  // you have to call this extension class to use this as this is not yet supported
  static TenantType? type(String name) => fromMap[name];

  static Map<String, TenantType> fromMap = {
    'System': TenantType.system,
    'Test': TenantType.test,
    'Production': TenantType.production
  };
  static Map<TenantType, String> toMap = {
    TenantType.system: 'System',
    TenantType.test: 'Test',
    TenantType.production: 'Production'
  };

  static TenantType? fromJson(dynamic? data) =>
      data == null ? null : fromMap[data];

  dynamic toJson() => toMap[this];

  static List<TenantType> listFromJson(List<dynamic>? json) => json == null
      ? <TenantType>[]
      : json.map((value) => fromJson(value)).toList().fromNull();

  static TenantType copyWith(TenantType instance) => instance;

  static Map<String, TenantType> mapFromJson(Map<String, dynamic?>? json) {
    final map = <String, TenantType>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic? value) {
        final val = fromJson(value);
        if (val != null) {
          map[key] = val;
        }
      });
    }
    return map;
  }
}
