part of trober_sdk.api;

// Terminal
class Terminal {
  String? id;

  DateTime? createdAt;

  DateTime? updatedAt;

  String? createdBy;

  String? tenantId;

  String? name;

  TerminalType? type;
  Terminal({
    this.id,
    this.createdAt,
    this.updatedAt,
    this.createdBy,
    this.tenantId,
    this.name,
    this.type,
  });

  @override
  String toString() {
    return 'Terminal[id=$id, createdAt=$createdAt, updatedAt=$updatedAt, createdBy=$createdBy, tenantId=$tenantId, name=$name, type=$type, ]';
  }

  fromJson(Map<String, dynamic>? json) {
    if (json == null) return;

    id = (json[r'id'] == null) ? null : (json[r'id'] as String);

    createdAt = (json[r'created_at'] == null)
        ? null
        : DateTime.parse(json[r'created_at']);

    updatedAt = (json[r'updated_at'] == null)
        ? null
        : DateTime.parse(json[r'updated_at']);

    createdBy =
        (json[r'created_by'] == null) ? null : (json[r'created_by'] as String);

    tenantId =
        (json[r'tenant_id'] == null) ? null : (json[r'tenant_id'] as String);

    name = (json[r'name'] == null) ? null : (json[r'name'] as String);

    type = (json[r'type'] == null)
        ? null
        : TerminalTypeExtension.fromJson(json[r'type']);
  }

  Terminal.fromJson(Map<String, dynamic>? json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    if (id != null) {
      json[r'id'] = id;
    }
    if (createdAt != null) {
      json[r'created_at'] = createdAt?.toUtc().toIso8601String();
    }
    if (updatedAt != null) {
      json[r'updated_at'] = updatedAt?.toUtc().toIso8601String();
    }
    if (createdBy != null) {
      json[r'created_by'] = createdBy;
    }
    if (tenantId != null) {
      json[r'tenant_id'] = tenantId;
    }
    if (name != null) {
      json[r'name'] = name;
    }
    if (type != null) {
      json[r'type'] = type?.toJson();
    }
    return json;
  }

  static List<Terminal> listFromJson(List<dynamic>? json) {
    return json == null
        ? <Terminal>[]
        : json.map((value) => Terminal.fromJson(value)).toList();
  }

  static Map<String, Terminal> mapFromJson(Map<String, dynamic>? json) {
    final map = <String, Terminal>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = Terminal.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object? other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is Terminal && runtimeType == other.runtimeType) {
      return id == other.id &&
          createdAt == other.createdAt && // other

          updatedAt == other.updatedAt && // other

          createdBy == other.createdBy &&
          tenantId == other.tenantId &&
          name == other.name &&
          type == other.type;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    if (id != null) {
      hashCode = hashCode * 31 + id.hashCode;
    }

    if (createdAt != null) {
      hashCode = hashCode * 31 + createdAt.hashCode;
    }

    if (updatedAt != null) {
      hashCode = hashCode * 31 + updatedAt.hashCode;
    }

    if (createdBy != null) {
      hashCode = hashCode * 31 + createdBy.hashCode;
    }

    if (tenantId != null) {
      hashCode = hashCode * 31 + tenantId.hashCode;
    }

    if (name != null) {
      hashCode = hashCode * 31 + name.hashCode;
    }

    if (type != null) {
      hashCode = hashCode * 31 + type.hashCode;
    }

    return hashCode;
  }

  Terminal copyWith({
    String? id,
    DateTime? createdAt,
    DateTime? updatedAt,
    String? createdBy,
    String? tenantId,
    String? name,
    TerminalType? type,
  }) {
    id ??= this.id;
    createdAt ??= this.createdAt;
    updatedAt ??= this.updatedAt;
    createdBy ??= this.createdBy;
    tenantId ??= this.tenantId;
    name ??= this.name;
    type ??= this.type;

    final _copy_id = id;
    final _copy_createdAt = createdAt;
    final _copy_updatedAt = updatedAt;
    final _copy_createdBy = createdBy;
    final _copy_tenantId = tenantId;
    final _copy_name = name;
    final _copy_type = type;

    return Terminal(
      id: _copy_id,
      createdAt: _copy_createdAt,
      updatedAt: _copy_updatedAt,
      createdBy: _copy_createdBy,
      tenantId: _copy_tenantId,
      name: _copy_name,
      type: _copy_type,
    );
  }
}
