part of trober_sdk.api;

enum TerminalType { rail, port, airport, warehouse, yard, custom }

extension TerminalTypeExtension on TerminalType {
  String? get name => toMap[this];

  // you have to call this extension class to use this as this is not yet supported
  static TerminalType? type(String name) => fromMap[name];

  static Map<String, TerminalType> fromMap = {
    'Rail': TerminalType.rail,
    'Port': TerminalType.port,
    'Airport': TerminalType.airport,
    'Warehouse': TerminalType.warehouse,
    'Yard': TerminalType.yard,
    'Custom': TerminalType.custom
  };
  static Map<TerminalType, String> toMap = {
    TerminalType.rail: 'Rail',
    TerminalType.port: 'Port',
    TerminalType.airport: 'Airport',
    TerminalType.warehouse: 'Warehouse',
    TerminalType.yard: 'Yard',
    TerminalType.custom: 'Custom'
  };

  static TerminalType? fromJson(dynamic? data) =>
      data == null ? null : fromMap[data];

  dynamic toJson() => toMap[this];

  static List<TerminalType> listFromJson(List<dynamic>? json) => json == null
      ? <TerminalType>[]
      : json.map((value) => fromJson(value)).toList().fromNull();

  static TerminalType copyWith(TerminalType instance) => instance;

  static Map<String, TerminalType> mapFromJson(Map<String, dynamic?>? json) {
    final map = <String, TerminalType>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic? value) {
        final val = fromJson(value);
        if (val != null) {
          map[key] = val;
        }
      });
    }
    return map;
  }
}
