part of trober_sdk.api;

// User
class User {
  late String id = '00000000-0000-0000-0000-000000000000';

  late DateTime createdAt;

  late DateTime updatedAt;

  String? createdBy;

  late String tenantId;

  String? customerId;

  late String name;

  late String username;

  late String email;

  late UserRole role;
  User({
    required this.id,
    required this.createdAt,
    required this.updatedAt,
    this.createdBy,
    required this.tenantId,
    this.customerId,
    required this.name,
    required this.username,
    required this.email,
    required this.role,
  });

  @override
  String toString() {
    return 'User[id=$id, createdAt=$createdAt, updatedAt=$updatedAt, createdBy=$createdBy, tenantId=$tenantId, customerId=$customerId, name=$name, username=$username, email=$email, role=$role, ]';
  }

  fromJson(Map<String, dynamic>? json) {
    if (json == null) return;

    {
      final _jsonData = json[r'id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'id', r'',
            'id field is null and is required to have a value');
      id = (_jsonData as String);
    }

    {
      final _jsonData = json[r'created_at'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'created_at', r'',
            'createdAt field is null and is required to have a value');
      createdAt = DateTime.parse(_jsonData);
    }

    {
      final _jsonData = json[r'updated_at'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'updated_at', r'',
            'updatedAt field is null and is required to have a value');
      updatedAt = DateTime.parse(_jsonData);
    }

    createdBy =
        (json[r'created_by'] == null) ? null : (json[r'created_by'] as String);

    {
      final _jsonData = json[r'tenant_id'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'tenant_id', r'',
            'tenantId field is null and is required to have a value');
      tenantId = (_jsonData as String);
    }

    customerId = (json[r'customer_id'] == null)
        ? null
        : (json[r'customer_id'] as String);

    {
      final _jsonData = json[r'name'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'name', r'',
            'name field is null and is required to have a value');
      name = (_jsonData as String);
    }

    {
      final _jsonData = json[r'username'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'username', r'',
            'username field is null and is required to have a value');
      username = (_jsonData as String);
    }

    {
      final _jsonData = json[r'email'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'email', r'',
            'email field is null and is required to have a value');
      email = (_jsonData as String);
    }

    {
      final _jsonData = json[r'role'];
      if (_jsonData == null)
        throw DeserialisationError(json, r'role', r'',
            'role field is null and is required to have a value');

      final _enumVal = UserRoleExtension.fromJson(_jsonData);
      if (_enumVal == null)
        throw DeserialisationError(json, r'role', r'',
            'UserRole has no valid translation from $_enumVal');
      role = _enumVal;
    }
  }

  User.fromJson(Map<String, dynamic>? json) {
    fromJson(json); // allows child classes to call
  }

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'id'] = id;
    json[r'created_at'] = createdAt.toUtc().toIso8601String();
    json[r'updated_at'] = updatedAt.toUtc().toIso8601String();
    if (createdBy != null) {
      json[r'created_by'] = createdBy;
    }
    json[r'tenant_id'] = tenantId;
    if (customerId != null) {
      json[r'customer_id'] = customerId;
    }
    json[r'name'] = name;
    json[r'username'] = username;
    json[r'email'] = email;
    json[r'role'] = role.toJson();
    return json;
  }

  static List<User> listFromJson(List<dynamic>? json) {
    return json == null
        ? <User>[]
        : json.map((value) => User.fromJson(value)).toList();
  }

  static Map<String, User> mapFromJson(Map<String, dynamic>? json) {
    final map = <String, User>{};
    if (json != null && json.isNotEmpty) {
      json.forEach(
          (String key, dynamic value) => map[key] = User.fromJson(value));
    }
    return map;
  }

  @override
  bool operator ==(Object? other) {
    if (identical(this, other)) {
      return true;
    }

    if (other is User && runtimeType == other.runtimeType) {
      return id == other.id &&
          createdAt == other.createdAt && // other

          updatedAt == other.updatedAt && // other

          createdBy == other.createdBy &&
          tenantId == other.tenantId &&
          customerId == other.customerId &&
          name == other.name &&
          username == other.username &&
          email == other.email &&
          role == other.role;
    }

    return false;
  }

  @override
  int get hashCode {
    var hashCode = runtimeType.hashCode;

    hashCode = hashCode * 31 + id.hashCode;

    hashCode = hashCode * 31 + createdAt.hashCode;

    hashCode = hashCode * 31 + updatedAt.hashCode;

    if (createdBy != null) {
      hashCode = hashCode * 31 + createdBy.hashCode;
    }

    hashCode = hashCode * 31 + tenantId.hashCode;

    if (customerId != null) {
      hashCode = hashCode * 31 + customerId.hashCode;
    }

    hashCode = hashCode * 31 + name.hashCode;

    hashCode = hashCode * 31 + username.hashCode;

    hashCode = hashCode * 31 + email.hashCode;

    hashCode = hashCode * 31 + role.hashCode;

    return hashCode;
  }

  User copyWith({
    String? id,
    DateTime? createdAt,
    DateTime? updatedAt,
    String? createdBy,
    String? tenantId,
    String? customerId,
    String? name,
    String? username,
    String? email,
    UserRole? role,
  }) {
    id ??= this.id;
    createdAt ??= this.createdAt;
    updatedAt ??= this.updatedAt;
    createdBy ??= this.createdBy;
    tenantId ??= this.tenantId;
    customerId ??= this.customerId;
    name ??= this.name;
    username ??= this.username;
    email ??= this.email;
    role ??= this.role;

    final _copy_id = id;
    final _copy_createdAt = createdAt;
    final _copy_updatedAt = updatedAt;
    final _copy_createdBy = createdBy;
    final _copy_tenantId = tenantId;
    final _copy_customerId = customerId;
    final _copy_name = name;
    final _copy_username = username;
    final _copy_email = email;
    final _copy_role = role;

    return User(
      id: _copy_id,
      createdAt: _copy_createdAt,
      updatedAt: _copy_updatedAt,
      createdBy: _copy_createdBy,
      tenantId: _copy_tenantId,
      customerId: _copy_customerId,
      name: _copy_name,
      username: _copy_username,
      email: _copy_email,
      role: _copy_role,
    );
  }
}
