part of trober_sdk.api;

enum UserRole { superAdmin, admin, backOffice, driver, customer, none }

extension UserRoleExtension on UserRole {
  String? get name => toMap[this];

  // you have to call this extension class to use this as this is not yet supported
  static UserRole? type(String name) => fromMap[name];

  static Map<String, UserRole> fromMap = {
    'SuperAdmin': UserRole.superAdmin,
    'Admin': UserRole.admin,
    'BackOffice': UserRole.backOffice,
    'Driver': UserRole.driver,
    'Customer': UserRole.customer,
    'None': UserRole.none
  };
  static Map<UserRole, String> toMap = {
    UserRole.superAdmin: 'SuperAdmin',
    UserRole.admin: 'Admin',
    UserRole.backOffice: 'BackOffice',
    UserRole.driver: 'Driver',
    UserRole.customer: 'Customer',
    UserRole.none: 'None'
  };

  static UserRole? fromJson(dynamic? data) =>
      data == null ? null : fromMap[data];

  dynamic toJson() => toMap[this];

  static List<UserRole> listFromJson(List<dynamic>? json) => json == null
      ? <UserRole>[]
      : json.map((value) => fromJson(value)).toList().fromNull();

  static UserRole copyWith(UserRole instance) => instance;

  static Map<String, UserRole> mapFromJson(Map<String, dynamic?>? json) {
    final map = <String, UserRole>{};
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic? value) {
        final val = fromJson(value);
        if (val != null) {
          map[key] = val;
        }
      });
    }
    return map;
  }
}
